//+-----------------------------------------------------------------------------------------------+
//|                                                                       Only_Profit_H4_beta.mq4 |
//|                                                                             Beta Version: 108 |
//|                                                                     Copyright  2009, artsnz. |
//|                                                                              artsnz@gmail.com |
//+-----------------------------------------------------------------------------------------------+
#property copyright "Copyright  2009, artsnz."
#property link      "artsnz@gmail.com"

//+-----------------------------------------------------------------------------------------------+
//|  .                                                                            |
//+-----------------------------------------------------------------------------------------------+
extern double lot = 1.0;
extern bool   deBug = true;
extern bool   TrailingStop = false;
extern int    TrailingStep = 10;
extern color  iColor = White;


//+-----------------------------------------------------------------------------------------------+
//|  .                                                                        |
//+-----------------------------------------------------------------------------------------------+
int ticket.buy, ticket.sell;
int Magic;

//+-----------------------------------------------------------------------------------------------+
//|  .                                                                       |
//+-----------------------------------------------------------------------------------------------+
void init()
 {
  Magic = Get.Magic();
 }
 
//+-----------------------------------------------------------------------------------------------+
//|   .                                                                        |
//+-----------------------------------------------------------------------------------------------+
void start()
 {
  // TRO_InsideBar_Plot2.
  if (IsTesting()) iCustom(NULL, 0, "TRO_InsideBar_Plot2", 50, true, Blue, Lime, 0, 0);
  double LineGreen = ObjectGet("HIGH_0", OBJPROP_PRICE1);
  double LineRed = ObjectGet("LOW_0", OBJPROP_PRICE1);

  // IBFX - CPR.
  if (IsTesting()) iCustom(NULL, 0, "IBFX - CPR", true,  true, true, true, DarkBlue, DimGray, 
                                                            Lime, Red, Blue, FireBrick, 50, 0, 0);
  double StopLoss = ObjectGet("STOPTARGET", OBJPROP_PRICE1);
  double TakeProfit = ObjectGet("PROFITTARGET", OBJPROP_PRICE1);
  color ZM30 = ObjectGet("ScanM30O", OBJPROP_COLOR),
        ZH1 = ObjectGet("ScanH1O", OBJPROP_COLOR),
        ZH4 = ObjectGet("ScanH4O", OBJPROP_COLOR),
        expRecomend = ObjectGet("Commentary4", OBJPROP_COLOR);
  
  // Trend.
  double trend.buy = iCustom(NULL,0,"trend",15,3,0,0,0),
         trend.sell = iCustom(NULL,0,"trend",15,3,0,1,0);
         
  // .       
  double spread = MarketInfo(Symbol(), MODE_SPREAD)*Point;       
  
  // 
  if (deBug) inf(LineRed, LineGreen, ZM30, ZH1, ZH4, expRecomend, trend.buy, 
                                                              trend.sell, StopLoss, TakeProfit);
  //  .
  Trailing.Stop();
    
  if (trend.buy != EMPTY_VALUE && Close[1] > LineGreen && Ask < TakeProfit - spread && 
      OrdersTotal() < 1 && ZM30 == Lime && ZH1 == Lime && ZH4 == Lime && expRecomend == Lime &&
      Ask + MarketInfo(Symbol(), MODE_STOPLEVEL)*Point < TakeProfit &&
      Ask - MarketInfo(Symbol(), MODE_STOPLEVEL)*Point > StopLoss)
   {
    for (int i = 0; i< OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderComment() == "Only_profit_H4" + Symbol() && OrderType() == OP_SELL) if(OrderClose(
                   OrderTicket(), lot, NormalizeDouble(Bid, Digits), 3, White)) ticket.sell = 0;
     } 
    ticket.buy = OrderSend (Symbol(), OP_BUY, lot, NormalizeDouble(Ask, Digits), 3, 
                                   StopLoss, TakeProfit, "Only_profit_H4"+Symbol(), Magic, Lime);
   }
  else if (trend.sell != EMPTY_VALUE && Close[1] < LineRed && Bid > TakeProfit + spread &&
           OrdersTotal() < 1 && ZM30 == Red && ZH1 == Red && ZH4 == Red && expRecomend == Red &&
           Bid - MarketInfo(Symbol(), MODE_STOPLEVEL)*Point > TakeProfit &&
           Bid + MarketInfo(Symbol(), MODE_STOPLEVEL)*Point < StopLoss)
        {
         for (int j = 0; j< OrdersTotal(); j++)
          {
           OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
           if (OrderComment() == "Only_profit_H4" + Symbol() && OrderType() == OP_BUY) 
           if(OrderClose(OrderTicket(), lot, NormalizeDouble(Ask, Digits), 3, White)) 
                                                                                   ticket.buy = 0;
          } 
         ticket.sell = OrderSend (Symbol(), OP_SELL, lot, NormalizeDouble(Bid, Digits), 3, 
                                   StopLoss, TakeProfit, "Only_profit_H4" + Symbol(), Magic, Red);
        }
  
 }

//+-----------------------------------------------------------------------------------------------+
//|  .                                                                 |
//+-----------------------------------------------------------------------------------------------+
void Trailing.Stop()
 {
  double ask, bid, point = MarketInfo(OrderSymbol(), MODE_POINT);
  for (int i = 0; i< OrdersTotal(); i++)
   {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    if (OrderComment() == "Only_profit_H4" + Symbol() && OrderType() == OP_BUY)
     {
      bid = MarketInfo(OrderSymbol(), MODE_BID);
      if (OrderStopLoss() < bid - TrailingStep*point)
      OrderModify (OrderTicket(), OrderOpenPrice(), bid - TrailingStep * point, OrderTakeProfit(), OrderExpiration(), CLR_NONE);
     }
    
    if (OrderComment() == "Only_profit_H4" + Symbol() && OrderType() == OP_SELL)
     {
      ask = MarketInfo(OrderSymbol(), MODE_ASK);
      if (OrderStopLoss() > ask + TrailingStep*point)
      OrderModify (OrderTicket(), OrderOpenPrice(), ask + TrailingStep * point, OrderTakeProfit(), OrderExpiration(), CLR_NONE);
     }
   }  
 } 
 
//+-----------------------------------------------------------------------------------------------+
//|   .                                                                 |
//+-----------------------------------------------------------------------------------------------+
int Get.Magic()
 {
  string mag;
  int Magic.g;
  Sleep(1000);
  while (true)
   {
    MathSrand (TimeLocal());
    mag = StringConcatenate(mag, MathRand()/15, MathRand()/8, MathRand()/32); 
    Magic.g = MathRound(MathAbs(StrToInteger(mag)));
    mag = DoubleToStr(Magic.g,10);
    if (StringLen (mag) >= 15) {Magic.g = StrToInteger(mag); break;}
   }
  return (MathRound(MathAbs(Magic.g)));
 }
 
//+-----------------------------------------------------------------------------------------------+
//|  deBug.                                                                                  |
//+-----------------------------------------------------------------------------------------------+ 
void inf(double LineRed, double LineGreen, color ZM30, color ZH1, color ZH4, 
       color expRecomend, double trend.buy, double trend.sell, double StopLoss, double TakeProfit)
 {
  ObjectCreate("Inform.x1", OBJ_LABEL, 0, 0, 0);
  ObjectSet("Inform.x1", OBJPROP_CORNER, 1);
  ObjectSetText("Inform.x1", "LineGreen: "+DoubleToStr(LineGreen, 5), 10, "Times New Roman", 
                                                                                          iColor);
  ObjectSet("Inform.x1", OBJPROP_XDISTANCE, 5);
  ObjectSet("Inform.x1", OBJPROP_YDISTANCE, 15);
  
  ObjectCreate("Inform.x2", OBJ_LABEL, 0, 0, 0);
  ObjectSet("Inform.x2", OBJPROP_CORNER, 1);
  ObjectSetText("Inform.x2", "LineRed: "+DoubleToStr(LineRed, 5), 10, "Times New Roman", iColor);
  ObjectSet("Inform.x2", OBJPROP_XDISTANCE, 5);
  ObjectSet("Inform.x2", OBJPROP_YDISTANCE, 30); 
  
  ObjectCreate("Inform.x3", OBJ_LABEL, 0, 0, 0);
  ObjectSet("Inform.x3", OBJPROP_CORNER, 1);
  if (ZM30 == Lime)
  ObjectSetText("Inform.x3", "M30: Buy", 10, "Times New Roman", iColor);
  if (ZM30 == Red)
  ObjectSetText("Inform.x3", "M30: Sell", 10, "Times New Roman", iColor);
  ObjectSet("Inform.x3", OBJPROP_XDISTANCE, 5);
  ObjectSet("Inform.x3", OBJPROP_YDISTANCE, 45); 
  
  ObjectCreate("Inform.x4", OBJ_LABEL, 0, 0, 0);
  ObjectSet("Inform.x4", OBJPROP_CORNER, 1);
  if (ZH1 == Lime)
  ObjectSetText("Inform.x4", "H1: Buy", 10, "Times New Roman", iColor);
  if (ZH1 == Red)
  ObjectSetText("Inform.x4", "H1: Sell", 10, "Times New Roman", iColor);
  ObjectSet("Inform.x4", OBJPROP_XDISTANCE, 5);
  ObjectSet("Inform.x4", OBJPROP_YDISTANCE, 60);
  
  ObjectCreate("Inform.x5", OBJ_LABEL, 0, 0, 0);
  ObjectSet("Inform.x5", OBJPROP_CORNER, 1);
  if (ZH4 == Lime)
  ObjectSetText("Inform.x5", "H4: Buy", 10, "Times New Roman", iColor);
  if (ZH4 == Red)
  ObjectSetText("Inform.x5", "H4: Sell", 10, "Times New Roman", iColor);
  ObjectSet("Inform.x5", OBJPROP_XDISTANCE, 5);
  ObjectSet("Inform.x5", OBJPROP_YDISTANCE, 75);
  
  ObjectCreate("Inform.x6", OBJ_LABEL, 0, 0, 0);
  ObjectSet("Inform.x6", OBJPROP_CORNER, 1);
  if (expRecomend == Lime)
  ObjectSetText("Inform.x6", ": Buy", 10, "Times New Roman", iColor);
  if (expRecomend == Red)
  ObjectSetText("Inform.x6", ": Sell", 10, "Times New Roman", iColor);
  ObjectSet("Inform.x6", OBJPROP_XDISTANCE, 5);
  ObjectSet("Inform.x6", OBJPROP_YDISTANCE, 90);
  
  ObjectCreate("Inform.x7", OBJ_LABEL, 0, 0, 0);
  ObjectSet("Inform.x7", OBJPROP_CORNER, 1);
  if (trend.buy != EMPTY_VALUE)
  ObjectSetText("Inform.x7", "Trend: Buy", 10, "Times New Roman", iColor);
  if (trend.sell != EMPTY_VALUE)
  ObjectSetText("Inform.x7", "Trend: Sell", 10, "Times New Roman", iColor);
  ObjectSet("Inform.x7", OBJPROP_XDISTANCE, 5);
  ObjectSet("Inform.x7", OBJPROP_YDISTANCE, 105);
  
  ObjectCreate("Inform.x8", OBJ_LABEL, 0, 0, 0);
  ObjectSet("Inform.x8", OBJPROP_CORNER, 1);
  ObjectSetText("Inform.x8", "StopLoss: "+DoubleToStr(StopLoss, 5), 10, "Times New Roman", iColor);
  ObjectSet("Inform.x8", OBJPROP_XDISTANCE, 5);
  ObjectSet("Inform.x8", OBJPROP_YDISTANCE, 120); 
  
  ObjectCreate("Inform.x9", OBJ_LABEL, 0, 0, 0);
  ObjectSet("Inform.x9", OBJPROP_CORNER, 1);
  ObjectSetText("Inform.x9", "TakeProfit: "+DoubleToStr(TakeProfit, 5), 10, "Times New Roman",
                                                                                           iColor);
  ObjectSet("Inform.x9", OBJPROP_XDISTANCE, 5);
  ObjectSet("Inform.x9", OBJPROP_YDISTANCE, 135);   
 }
//+-----------------------------------------------------------------------------------------------+
//|   .                                                                          |
//+-----------------------------------------------------------------------------------------------+